Index: trunk/src/lib/graphics/text_engine/font.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/font.cc	(revision 7428)
+++ trunk/src/lib/graphics/text_engine/font.cc	(revision 7429)
@@ -380,4 +380,5 @@
                      &miY, &maY,
                      &adv);
+    printf("%c:: %d %d %d %d %d\n", rg->character, miX, maX, miY, maY, adv);
     rg->minX = (float)miX / (float)this->renderSize;
     rg->maxX = (float)maX / (float)this->renderSize;
@@ -471,10 +472,10 @@
         tmpRect.y = tmp;
 
-        tmpGlyph->texCoord[0] = (float)(tmpRect.x)/(float)tmpSurf->w;
-        tmpGlyph->texCoord[1] = (float)(tmpRect.x + tmpGlyph->width*(float)this->renderSize)/(float)tmpSurf->w;
+        tmpGlyph->texCoord[0] = (float)((float)tmpRect.x + tmpGlyph->minX*(float)this->renderSize)/(float)tmpSurf->w;
+        tmpGlyph->texCoord[1] = (float)((float)tmpRect.x + tmpGlyph->maxX*(float)this->renderSize)/(float)tmpSurf->w;
         tmpGlyph->texCoord[2] = (float)(tmpRect.y)/(float)tmpSurf->w;
-        tmpGlyph->texCoord[3] = (float)(tmpRect.y+this->getMaxHeight())/(float)tmpSurf->w;
+        tmpGlyph->texCoord[3] = (float)((float)tmpRect.y+(float)this->getMaxHeight())/(float)tmpSurf->w;
         SDL_FreeSurface(glyphSurf);
-        tmpRect.x += (int)(tmpGlyph->advance * this->renderSize)+1;
+        tmpRect.x += glyphSurf->w+1; //(int)(tmpGlyph->advance * this->renderSize);
 
         /*
@@ -492,7 +493,7 @@
   }
   // outputting the GLYPH-table
-  //   char outName[1024];
-  //   sprintf( outName, "%s-glyphs.bmp", this->getName());
-  //   SDL_SaveBMP(tmpSurf, outName);
+     char outName[1024];
+     sprintf( outName, "%s-glyphs.bmp", this->getName());
+     SDL_SaveBMP(tmpSurf, outName);
 
   if (this->setSurface(tmpSurf))
Index: trunk/src/lib/graphics/text_engine/text.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/text.cc	(revision 7428)
+++ trunk/src/lib/graphics/text_engine/text.cc	(revision 7429)
@@ -164,14 +164,14 @@
       {
         glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[2]);
-        glVertex2d(posX+tmpGlyph->width*this->getSizeY2D(), 0);
+        glVertex2d(posX+tmpGlyph->advance*this->getSizeY2D(), 0);
 
         glTexCoord2f(tmpGlyph->texCoord[1], tmpGlyph->texCoord[3]);
-        glVertex2d(posX+tmpGlyph->width*this->getSizeY2D(), this->getSizeY2D());
+        glVertex2d(posX+tmpGlyph->advance*this->getSizeY2D(), this->getSizeY2D());
 
         glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[3]);
-        glVertex2d(posX, this->getSizeY2D());
+        glVertex2d(posX+tmpGlyph->minX*this->getSizeY2D(), this->getSizeY2D());
 
         glTexCoord2f(tmpGlyph->texCoord[0], tmpGlyph->texCoord[2]);
-        glVertex2d(posX, 0);
+        glVertex2d(posX+tmpGlyph->minX*this->getSizeY2D(), 0);
 
         posX += tmpGlyph->advance * this->getSizeY2D();
Index: trunk/src/lib/lang/base_object.cc
===================================================================
--- trunk/src/lib/lang/base_object.cc	(revision 7428)
+++ trunk/src/lib/lang/base_object.cc	(revision 7429)
@@ -41,5 +41,5 @@
   this->xmlElem = NULL;
 
-//  ClassList::addToClassList(this, this->classID, "BaseObject");
+  //ClassList::addToClassList(this, this->classID, "BaseObject");
 }
 
Index: trunk/src/lib/lang/class_list.cc
===================================================================
--- trunk/src/lib/lang/class_list.cc	(revision 7428)
+++ trunk/src/lib/lang/class_list.cc	(revision 7429)
@@ -21,7 +21,6 @@
 #include "compiler.h"
 #include "debug.h"
-#include <string.h>
 #include <cmath>
-#include <algorithm>
+
 using namespace std;
 
Index: trunk/src/lib/lang/class_list.h
===================================================================
--- trunk/src/lib/lang/class_list.h	(revision 7428)
+++ trunk/src/lib/lang/class_list.h	(revision 7429)
@@ -11,7 +11,4 @@
 #include <list>
 #include <string>
-#ifndef NULL
-#define NULL     0    //!< NULL
-#endif
 
 // FORWARD DECLARATION