Index: /sandbox_qt/src/orxonox/CMakeLists.txt
===================================================================
--- /sandbox_qt/src/orxonox/CMakeLists.txt	(revision 7429)
+++ /sandbox_qt/src/orxonox/CMakeLists.txt	(revision 7430)
@@ -25,4 +25,5 @@
 SET_SOURCE_FILES(ORXONOX_SRC_FILES
   Main.cc
+  MainWindow.cc
 )
 
@@ -31,4 +32,8 @@
 ORXONOX_ADD_LIBRARY(orxonox
   FIND_HEADER_FILES
+  QT_MOC_FILES
+    MainWindow.h
+  QT_UIC_FILES
+    MainWindow.ui
   LINK_LIBRARIES
     ${QT_QTCORE_LIBRARY}
Index: /sandbox_qt/src/orxonox/Main.cc
===================================================================
--- /sandbox_qt/src/orxonox/Main.cc	(revision 7429)
+++ /sandbox_qt/src/orxonox/Main.cc	(revision 7430)
@@ -34,5 +34,5 @@
 */
 
-#include "OrxonoxPrereqs.h"
+#include "Main.h"
 
 #include <QApplication>
@@ -42,5 +42,5 @@
 #include "core/CommandLineParser.h"
 #include "core/Core.h"
-#include "Main.h"
+#include "MainWindow.h"
 
 namespace orxonox
@@ -62,10 +62,19 @@
         Core core(arguments.join(" ").toStdString());
 
-        QCoreApplication::setOrganizationName("");
-        QCoreApplication::setOrganizationDomain("");
-        QCoreApplication::setApplicationName("");
+        QCoreApplication::setOrganizationName("Orxonox");
+        QCoreApplication::setOrganizationDomain("www.orxonox.net");
+        QCoreApplication::setApplicationName("Orxonox Sandbox");
+        QString versionString;
+        versionString += QString::number(ORXONOX_VERSION_MAJOR);
+        versionString += QString::number(ORXONOX_VERSION_MINOR);
+        versionString += QString::number(ORXONOX_VERSION_PATCH);
+        QCoreApplication::setApplicationVersion(versionString);
 
         if (CommandLineParser::getValue("generateDoc").toString().isEmpty())
+        {
+            MainWindow window;
+            window.show();
             return app.exec();
+        }
         else
             return 0;
Index: /sandbox_qt/src/orxonox/MainWindow.cc
===================================================================
--- /sandbox_qt/src/orxonox/MainWindow.cc	(revision 7430)
+++ /sandbox_qt/src/orxonox/MainWindow.cc	(revision 7430)
@@ -0,0 +1,37 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "MainWindow.h"
+
+namespace orxonox
+{
+    MainWindow::MainWindow()
+    {
+        setupUi(this);
+    }
+}
Index: /sandbox_qt/src/orxonox/MainWindow.h
===================================================================
--- /sandbox_qt/src/orxonox/MainWindow.h	(revision 7430)
+++ /sandbox_qt/src/orxonox/MainWindow.h	(revision 7430)
@@ -0,0 +1,48 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _MainWindow_H__
+#define _MainWindow_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <QMainWindow>
+#include "orxonox/ui_MainWindow.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport MainWindow : public QMainWindow, private Ui::MainWindow
+    {
+        Q_OBJECT();
+
+    public:
+        MainWindow();
+    };
+}
+
+#endif /* _MainWindow_H__ */
Index: /sandbox_qt/src/orxonox/MainWindow.ui
===================================================================
--- /sandbox_qt/src/orxonox/MainWindow.ui	(revision 7430)
+++ /sandbox_qt/src/orxonox/MainWindow.ui	(revision 7430)
@@ -0,0 +1,31 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<ui version="4.0">
+ <class>MainWindow</class>
+ <widget class="QMainWindow" name="MainWindow">
+  <property name="geometry">
+   <rect>
+    <x>0</x>
+    <y>0</y>
+    <width>800</width>
+    <height>600</height>
+   </rect>
+  </property>
+  <property name="windowTitle">
+   <string>MainWindow</string>
+  </property>
+  <widget class="QWidget" name="centralwidget"/>
+  <widget class="QMenuBar" name="menubar">
+   <property name="geometry">
+    <rect>
+     <x>0</x>
+     <y>0</y>
+     <width>800</width>
+     <height>21</height>
+    </rect>
+   </property>
+  </widget>
+  <widget class="QStatusBar" name="statusbar"/>
+ </widget>
+ <resources/>
+ <connections/>
+</ui>