Index: code/branches/tutorial2/data/levels/tutorial.oxw
===================================================================
--- code/branches/tutorial2/data/levels/tutorial.oxw	(revision 7444)
+++ code/branches/tutorial2/data/levels/tutorial.oxw	(revision 7446)
@@ -28,20 +28,4 @@
 
     <!-- TODO: Insert drone here. -->
-    <!-- TODO: Remove. -->
-    <AutonomousDrone
-      primaryThrust = 100
-      auxiliaryThrust = 30
-      rotationThrust = 25
-      mass = 50
-      linearDamping = 0.9
-      angularDamping = 0.7
-    >
-      <attached>
-        <Model scale="10" mesh="drone.mesh"/>
-      </attached>
-      <collisionShapes>
-        <BoxCollisionShape position="0,0,0" halfExtents="10, 10, 10" />
-      </collisionShapes>
-    </AutonomousDrone>
 
   </Scene>
Index: code/branches/tutorial2/src/orxonox/controllers/AutonomousDroneController.cc
===================================================================
--- code/branches/tutorial2/src/orxonox/controllers/AutonomousDroneController.cc	(revision 7444)
+++ code/branches/tutorial2/src/orxonox/controllers/AutonomousDroneController.cc	(revision 7446)
@@ -46,6 +46,4 @@
         // Make sure to register the object in the factory.
         // Do some kind of initialisation.
-        //TODO: Remove.
-        RegisterObject(AutonomousDroneController);
 
         // This checks that our creator really is a drone
@@ -80,8 +78,4 @@
         // - rotatePitch, rotateYaw, rotateRoll
         // Apply the to myDrone (e.g. myDrone->rotateYaw(..) )
-        //TODO: Remove:
-        myDrone->rotateRoll(dt*2);
-        myDrone->moveFrontBack(dt*50);
-        myDrone->rotateYaw(dt);
 
     }
Index: code/branches/tutorial2/src/orxonox/controllers/CMakeLists.txt
===================================================================
--- code/branches/tutorial2/src/orxonox/controllers/CMakeLists.txt	(revision 7444)
+++ code/branches/tutorial2/src/orxonox/controllers/CMakeLists.txt	(revision 7446)
@@ -1,4 +1,3 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
-  AutonomousDroneController.cc
   Controller.cc
   HumanController.cc
Index: code/branches/tutorial2/src/orxonox/worldentities/AutonomousDrone.cc
===================================================================
--- code/branches/tutorial2/src/orxonox/worldentities/AutonomousDrone.cc	(revision 7444)
+++ code/branches/tutorial2/src/orxonox/worldentities/AutonomousDrone.cc	(revision 7446)
@@ -36,6 +36,4 @@
     //TODO: Put your code in here:
     // Create the factory for the drone.
-    //TODO: Remove.
-    CreateFactory(AutonomousDrone);
 
     /**
@@ -49,6 +47,4 @@
         //TODO: Put your code in here:
         // Register the drone class to the core.
-        //TODO: Remove.
-        RegisterObject(AutonomousDrone);
 
         this->myController_ = NULL;
@@ -91,7 +87,4 @@
         // Variables can be added by the following command
         // XMLPortParam(Classname, "xml-attribute-name (i.e. variablename)", setFunction, getFunction, xmlelement, mode)
-        //TODO: Remove.
-        XMLPortParam(AutonomousDrone, "auxiliaryThrus", setAuxiliaryThrust, getAuxiliaryThrust, xmlelement, mode);
-        XMLPortParam(AutonomousDrone, "rotationThrust", setRotationThrust, getRotationThrust, xmlelement, mode);
 
     }
Index: code/branches/tutorial2/src/orxonox/worldentities/AutonomousDrone.h
===================================================================
--- code/branches/tutorial2/src/orxonox/worldentities/AutonomousDrone.h	(revision 7444)
+++ code/branches/tutorial2/src/orxonox/worldentities/AutonomousDrone.h	(revision 7446)
@@ -109,17 +109,4 @@
             //TODO: Place your set-functions here.
             // - hint: auxiliary thrust, rotation thrust.
-            //TODO: Remove.
-            /**
-            @brief Sets the auxiliary thrust to the input amount.
-            @param thrust The amount of thrust.
-            */
-            inline void setAuxiliaryThrust( float thrust )
-                { this->auxiliaryThrust_ = thrust; }
-            /**
-            @brief Sets the rotation thrust to the input amount.
-            @param thrust The amount of thrust.
-            */
-            inline void setRotationThrust( float thrust )
-                { this->rotationThrust_ = thrust; }
 
             /**
@@ -130,17 +117,4 @@
                 { return this->primaryThrust_; }
             //TODO: Place your get-functions here.
-            //TODO: Remove.
-            /**
-            @brief Gets the auxiliary thrust to the input amount.
-            @return The amount of thrust.
-            */
-            inline float getAuxiliaryThrust()
-                { return this->auxiliaryThrust_; }
-                /**
-            @brief Gets the rotation thrust to the input amount.
-            @return The amount of thrust.
-            */
-            inline float getRotationThrust()
-                { return this->rotationThrust_; }
 
         private:
Index: code/branches/tutorial2/src/orxonox/worldentities/CMakeLists.txt
===================================================================
--- code/branches/tutorial2/src/orxonox/worldentities/CMakeLists.txt	(revision 7444)
+++ code/branches/tutorial2/src/orxonox/worldentities/CMakeLists.txt	(revision 7446)
@@ -1,4 +1,3 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
-  AutonomousDrone.cc
   WorldEntity.cc
   StaticEntity.cc