Index: /trunk/src/lib/BuildLibs.am
===================================================================
--- /trunk/src/lib/BuildLibs.am	(revision 7452)
+++ /trunk/src/lib/BuildLibs.am	(revision 7453)
@@ -2,5 +2,4 @@
 libORXlibs_a_LIBRARIES_ = \
                 $(LIB_PREFIX)/libORXlibs.a \
-                $(LIB_PREFIX)/shell/libORXshell.a \
                 $(LIB_PREFIX)/gui/gtk_gui/libORXgui.a \
                 $(LIB_PREFIX)/gui/gl_gui/libORXglgui.a \
@@ -19,4 +18,5 @@
                 $(LIB_PREFIX)/parser/cmdline_parser/libCmdLineParser.a \
                 $(LIB_PREFIX)/parser/ini_parser/libIniParser.a \
+                $(LIB_PREFIX)/shell/libORXshell.a \
                 $(LIB_PREFIX)/math/libORXmath.a \
                 $(LIB_PREFIX)/libORXlibs.a
Index: /trunk/src/lib/graphics/render2D/render_2d.cc
===================================================================
--- /trunk/src/lib/graphics/render2D/render_2d.cc	(revision 7452)
+++ /trunk/src/lib/graphics/render2D/render_2d.cc	(revision 7453)
@@ -21,6 +21,4 @@
 #include "class_list.h"
 #include "element_2d.h"
-
-#include <math.h>
 
 #include "shell_command.h"
Index: /trunk/src/lib/graphics/text_engine/multi_line_text.cc
===================================================================
--- /trunk/src/lib/graphics/text_engine/multi_line_text.cc	(revision 7452)
+++ /trunk/src/lib/graphics/text_engine/multi_line_text.cc	(revision 7453)
@@ -117,7 +117,5 @@
 {
   this->lineEnds.clear();
-  this->lineEnds.push_back(0);
   float width = 0.0f;
-  // TODO make size local to this (not using the one from Element2D.
   float maxWidth = this->lineWidth / this->getSize();
 
@@ -133,3 +131,4 @@
       width += this->getFont()->getGlyphArray()[this->getText()[i]]->advance;
   }
+  this->setSizeY2D(this->lineEnds.size() * (this->lineSpacing+this->getFont()->getMaxHeight()));
 }
Index: /trunk/src/lib/graphics/text_engine/text.cc
===================================================================
--- /trunk/src/lib/graphics/text_engine/text.cc	(revision 7452)
+++ /trunk/src/lib/graphics/text_engine/text.cc	(revision 7453)
@@ -39,11 +39,9 @@
   this->blending = TEXT_DEFAULT_BLENDING;
   this->color = TEXT_DEFAULT_COLOR;
-  this->setSize(TEXT_DEFAULT_SIZE);
-  this->setText("");
-
 
   if (!fontFile.empty())
     this->setFont(fontFile, FONT_DEFAULT_RENDER_SIZE);
-  this->setSizeY2D(textSize);
+
+  this->setSize(TEXT_DEFAULT_SIZE);
 }
 
@@ -99,4 +97,17 @@
   this->setupTextWidth();
 }
+
+
+/**
+ * @brief sets the Size of the Font
+ * @param size :the size of the Text
+ */
+void Text::setSize(float size)
+{
+  this->size = size;
+  this->setSizeY2D(size);
+  this->setupTextWidth();
+}
+
 
 /**
Index: /trunk/src/lib/graphics/text_engine/text.h
===================================================================
--- /trunk/src/lib/graphics/text_engine/text.h	(revision 7452)
+++ /trunk/src/lib/graphics/text_engine/text.h	(revision 7453)
@@ -37,6 +37,5 @@
     /** @param r red @param g green @param b blue @brief sets the Color of the Text to render (values in [0-1]) */
     void setColor(float r, float g, float b) { this->color = Vector(r, g, b); };
-    /** @param size the Size of the Text @brief sets the Size of the Font */
-    inline void setSize(float size) { this->setSizeY2D(size); };
+    void setSize(float size);
 
     /// RETRIEVE
@@ -50,5 +49,5 @@
     inline const Vector& getColor() const { return this->color; };
     /** @returns the Size of the Text */
-    inline float getSize() const { return this->getSizeY2D(); };
+    inline float getSize() const { return this->size; };
 
     virtual void draw() const;
@@ -58,4 +57,5 @@
   protected:
     virtual void setupTextWidth();
+
   private:
     Font*             font;           //!< Font of this text
@@ -64,4 +64,5 @@
     Vector            color;          //!< The color of the font.
     float             blending;       //!< The blending intensity.
+    float             size;           //!< The size of the Text.
 };
 